import { PluginConfiguration } from '../../config/nx-json';
import { NxPluginV1 } from '../../utils/nx-plugin.deprecated';
import { CreateNodesContext, CreateNodesResult, NxPlugin, NxPluginV2 } from './public-api';
export type CreateNodesResultWithContext = CreateNodesResult & {
    file: string;
    pluginName: string;
};
export type NormalizedPlugin = NxPluginV2 & Pick<NxPluginV1, 'processProjectGraph'>;
export type RemotePlugin = Omit<NormalizedPlugin, 'createNodes'> & {
    createNodes: [
        filePattern: string,
        fn: (matchedFiles: string[], context: CreateNodesContext) => Promise<CreateNodesResultWithContext[]>
    ];
};
export declare const nxPluginCache: Map<unknown, RemotePlugin>;
export declare function loadNxPlugins(plugins: PluginConfiguration[], root?: string): Promise<RemotePlugin[]>;
export declare function loadNxPlugin(plugin: PluginConfiguration, root?: string): Promise<RemotePlugin>;
export declare function isNxPluginV2(plugin: NxPlugin): plugin is NxPluginV2;
export declare function isNxPluginV1(plugin: NxPlugin | RemotePlugin): plugin is NxPluginV1;
export declare function normalizeNxPlugin(plugin: NxPlugin): NormalizedPlugin;
export declare function getDefaultPlugins(root: string): Promise<string[]>;
